﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Newtonsoft.Json.Linq;
using System.Data.SQLite;
using System.IO;



namespace sqlie_json_test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            JArray recs = JArray.Parse(File.ReadAllText(@"arrRecords.json"));
         

            // JObjectの作成
            JObject obj = new JObject();
            obj["Name"] = "John Doe";
            obj["Age"] = 30;

            // JObjectを文字列にシリアライズ
            string json = obj.ToString();

            // SQLite接続の作成
            SQLiteConnection conn = new SQLiteConnection("Data Source=json_data.sqlite3;Version=3;");
            conn.Open();

            // コマンドの作成
            SQLiteCommand cmd = new SQLiteCommand(conn);
            //cmd.CommandText = "INSERT INTO tbl VALUES (2000, 'a', @json)";
            cmd.CommandText = "INSERT INTO tbl2 VALUES (@json)";

            foreach (JObject rec in recs)
            {
                Console.WriteLine(rec);
                cmd.Parameters.AddWithValue("@json", rec);

                // コマンドの実行
                cmd.ExecuteNonQuery();
            }




            // 接続のクローズ
            conn.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SQLiteConnection con = new SQLiteConnection("Data Source=json_data.sqlite3;Version=3;");
            con.Open();
            con.EnableExtensions(true);
            //con.LoadExtension("SQLite.Interop.dll", "sqlite3_json_init");
            try
            {
                string sql = "select * from tbl2 where json_extract(attr, '$.レコード番号.value')='24'";

                SQLiteCommand com = new SQLiteCommand(sql, con);
                SQLiteDataReader sdr = com.ExecuteReader();


                while (sdr.Read() == true)
                {
                    //Console.WriteLine(sdr[0]);
                    //Console.WriteLine(sdr[1]);
                    JObject obj = JObject.Parse(sdr[0].ToString());

                    //var obj = (JObject)sdr[1];
                    Console.WriteLine(obj);
                    //txt += string.Format("{0} {1}\n", (string)sdr["name"], (int)sdr["id"]);
                }
                //Console.WriteLine(txt);
                sdr.Close();
            }
            finally
            {
                con.Close();
            }
        }
    }
}
